local pbr = 0//pain boss rush
local ad = 0//all dead
COM_AddCommand("painbossrush", function (b, arg, COM_ADMIN)
	if arg == "1"
		if gamestate == 4 and titlemapinaction == true
			CONS_Printf(b, "painbossrush set to 1. Enter any PAIN level to begin. PAIN's BCZ1 doesn't count as a boss.")
			COM_BufInsertText(b, "devmode 1")
			COM_BufInsertText(b, "devmode 0")
			pbr = 1
		else
			CONS_Printf(b, "Try again at the Title Screen.")
		end
	elseif arg == "0"
		CONS_Printf(b, "painbossrush set to 0.")
		pbr = 0
	else
		CONS_Printf(b, "Toggles PAIN's Boss Rush Mode. 1 = on, 0 = off. The default value is 0. You may only set it to 1 at the Title Screen, but you can set it to 0 anywhere. WARNING: Setting this to 1 will mark your game as modified, preventing you from saving your progress.")
	end
end)//toggles boss rush mode on or off; read the CONS_Printf lines for more information
addHook("NetVars", function(net)
	pbr = net($)
end)//synchronizes Boss Rush Mode in netgames... hopefully
addHook("ThinkFrame", function()
	if pbr == 0
		return
	elseif (gamemap == 642 or gamemap == 645 or gamemap == 648 or gamemap == 651 or gamemap == 654 or gamemap == 658 or gamemap == 660 or gamemap == 661)
		return
	elseif pbr == 1	
	and (gamemap == 640 or gamemap == 641 or gamemap == 643 or gamemap == 644 or gamemap == 646 or gamemap == 647 or gamemap == 649 or gamemap == 650 or gamemap == 652 or gamemap == 653 or gamemap == 655 or gamemap == 656 or gamemap == 657 or gamemap == 659)
		G_SetCustomExitVars(642, 2)
		G_ExitLevel()
	end
end)//makes PAIN's non-boss levels teleport you to GFZ3 in boss rush mode
local function ad2()
	if multiplayer == true
		ad = 1
	end
end//sets ad, which stands for all dead, to 1 when triggered
addHook("LinedefExecute", ad2, "AD1")//calls the function, ad2, when a linedef executor with AD1 in its front upper texture is triggered
addHook("MapLoad", function(gamemap)
	if multiplayer == true
		ad = 0
	end
end)//sets ad to 0 upon map load
addHook("ThinkFrame", function()
	if not (gamemap == 642 or gamemap == 645 or gamemap == 648 or gamemap == 651 or gamemap == 654 or gamemap == 658 or gamemap == 660 or gamemap == 661)
		return
	elseif multiplayer == false
		return
	elseif gamemap == 642 and ad == 0 and pbr == 1
		G_SetCustomExitVars(645)
	elseif gamemap == 642 and ad == 1
		G_SetCustomExitVars(642, 2)
		G_ExitLevel()//GFZ3
	elseif gamemap == 645 and ad == 0 and pbr == 1
		G_SetCustomExitVars(648)
	elseif gamemap == 645 and ad == 1
		G_SetCustomExitVars(645, 2)
		G_ExitLevel()//THZ3
	elseif gamemap == 648 and ad == 0 and pbr == 1
		G_SetCustomExitVars(651)
	elseif gamemap == 648 and ad == 1
		G_SetCustomExitVars(648, 2)
		G_ExitLevel()//DSZ3
	elseif gamemap == 651 and ad == 0 and pbr == 1
		G_SetCustomExitVars(654)
	elseif gamemap == 651 and ad == 1
		G_SetCustomExitVars(651, 2)
		G_ExitLevel()//CEZ3
	elseif gamemap == 654 and ad == 0 and pbr == 1
		G_SetCustomExitVars(658)
	elseif gamemap == 654 and ad == 1
		G_SetCustomExitVars(654, 2)
		G_ExitLevel()//ACZ3
	elseif gamemap == 658 and ad == 0 and pbr == 1
		G_SetCustomExitVars(660)
	elseif gamemap == 658 and ad == 1
		G_SetCustomExitVars(658, 2)
		G_ExitLevel()//ERZ3
	elseif gamemap == 660 and ad == 1
		G_SetCustomExitVars(660, 2)
		G_ExitLevel()//BCZ2
	elseif gamemap == 661 and ad == 1
		G_SetCustomExitVars(661, 2)
		G_ExitLevel()//BCZ3
	elseif ad == 0 and pbr == 0
		G_SetCustomExitVars()
	end
end)